# Xapian::PostingIterator Class Reference

An iterator pointing to items in a list of postings. More...

`#include <postingiterator.h>`

Collaboration diagram for Xapian::PostingIterator:

[legend]
List of all members.

## Public Types

typedef std::input_iterator_tag | iterator_category
| Allow use as an STL iterator.
typedef Xapian::docid | value_type
typedef Xapian::doccount_diff | difference_type
typedef Xapian::docid * | pointer
typedef Xapian::docid & | reference

## Public Member Functions

| PostingIterator ()
| Default constructor - for declaring an uninitialised iterator.
| ~PostingIterator ()
| Destructor.
| PostingIterator (const PostingIterator &other)
| Copying is allowed.
void | operator= (const PostingIterator &other)
| Assignment is allowed.
PostingIterator & | operator++ ()
DocIDWrapper | operator++ (int)
void | skip_to (Xapian::docid did)
| Skip the iterator to document did, or the first document after did if did isn't in the list of documents being iterated.
Xapian::docid | operator * () const
| Get the document id at the current position in the postlist.
Xapian::doclength | get_doclength () const
| Get the length of the document at the current position in the postlist.
Xapian::termcount | get_wdf () const
| Get the within document frequency of the document at the current position in the postlist.
PositionIterator | positionlist_begin () const
| Return PositionIterator pointing to start of positionlist for current document.
PositionIterator | positionlist_end () const
| Return PositionIterator pointing to end of positionlist for current document.
std::string | get_description () const
| Returns a string describing this object.

## Public Attributes

Xapian::Internal::RefCntPtr< Internal > | internal

## Friends

class | Database
bool | operator== (const PostingIterator &a, const PostingIterator &b)
| Test equality of two PostingIterators.

## Detailed Description

An iterator pointing to items in a list of postings.

## Member Typedef Documentation

typedef std::input_iterator_tag Xapian::PostingIterator::iterator_category

| Allow use as an STL iterator.

## Constructor & Destructor Documentation

Xapian::PostingIterator::PostingIterator | ( |  | ) |

| Default constructor - for declaring an uninitialised iterator.

Xapian::PostingIterator::~PostingIterator | ( |  | ) |

| Destructor.

Xapian::PostingIterator::PostingIterator | ( | const PostingIterator & | other | ) |

| Copying is allowed. The internals are reference counted, so copying is also cheap.

## Member Function Documentation

std::string Xapian::PostingIterator::get_description | ( |  | ) | const

| Returns a string describing this object. Introspection method.

Xapian::doclength Xapian::PostingIterator::get_doclength | ( |  | ) | const

| Get the length of the document at the current position in the postlist. This information may be stored in the postlist, in which case this lookup should be extremely fast (indeed, not require further disk access). If the information is not present in the postlist, it will be retrieved from the database, at a greater performance cost.

Xapian::termcount Xapian::PostingIterator::get_wdf | ( |  | ) | const

| Get the within document frequency of the document at the current position in the postlist.

Xapian::docid Xapian::PostingIterator::operator * | ( |  | ) | const

| Get the document id at the current position in the postlist.

void Xapian::PostingIterator::operator= | ( | const PostingIterator & | other | ) |

| Assignment is allowed. The internals are reference counted, so assignment is also cheap.

PositionIterator Xapian::PostingIterator::positionlist_begin | ( |  | ) | const

| Return PositionIterator pointing to start of positionlist for current document.

PositionIterator Xapian::PostingIterator::positionlist_end | ( |  | ) | const`[inline]`

| Return PositionIterator pointing to end of positionlist for current document.

void Xapian::PostingIterator::skip_to | ( | Xapian::docid | did | ) |

| Skip the iterator to document did, or the first document after did if did isn't in the list of documents being iterated.

## Friends And Related Function Documentation

bool operator== | ( | const PostingIterator & | a,
|  | const PostingIterator & | b
| ) | `[friend]`

| Test equality of two PostingIterators.

The documentation for this class was generated from the following file:

- include/xapian/postingiterator.h